"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.ts
var highlight_pop_exports = {};
__export(highlight_pop_exports, {
  default: () => highlight_pop_default
});
module.exports = __toCommonJS(highlight_pop_exports);

// src/highlight.tsx
var import_react2 = require("react");

// src/hooks/use-effect-once.tsx
var import_react = require("react");
var useEffectOnce = (effect) => {
  (0, import_react.useEffect)(effect, []);
};

// src/highlight.tsx
var import_jsx_runtime = require("react/jsx-runtime");
function TextHighlightPopup({
  children,
  actions,
  getActionPayload = (text) => text
}) {
  const [isPopupVisible, setIsPopupVisible] = (0, import_react2.useState)(false);
  const [popupPosition, setPopupPosition] = (0, import_react2.useState)({ top: 0, left: 0 });
  const [selectedText, setSelectedText] = (0, import_react2.useState)("");
  const containerRef = (0, import_react2.useRef)(null);
  const popupRef = (0, import_react2.useRef)(null);
  const calculatePopupPosition = (0, import_react2.useCallback)((rect, containerRect) => {
    var _a, _b;
    const popupWidth = ((_a = popupRef.current) == null ? void 0 : _a.offsetWidth) || 0;
    const popupHeight = ((_b = popupRef.current) == null ? void 0 : _b.offsetHeight) || 0;
    let top = Math.max(0, rect.bottom - containerRect.top);
    let left = rect.left - containerRect.left + rect.width / 2;
    if (left + popupWidth > containerRect.width) {
      left = containerRect.width - popupWidth;
    } else if (left < 0) {
      left = 10;
    }
    if (top + popupHeight > containerRect.height) {
      top = rect.top - containerRect.top - popupHeight;
    } else if (top < 0) {
      top = 10;
    }
    return { top, left };
  }, []);
  const handleMouseUp = (0, import_react2.useCallback)(() => {
    var _a;
    const selection = window.getSelection();
    if (selection && selection.toString().trim().length > 0) {
      const range = selection.getRangeAt(0);
      const rect = range.getBoundingClientRect();
      const containerRect = (_a = containerRef.current) == null ? void 0 : _a.getBoundingClientRect();
      if (containerRect) {
        const newPosition = calculatePopupPosition(rect, containerRect);
        setPopupPosition(newPosition);
      }
      setSelectedText(selection.toString().trim());
      setIsPopupVisible(true);
    }
  }, [calculatePopupPosition]);
  const handleActionClick = (0, import_react2.useCallback)((action) => {
    const payload = getActionPayload(selectedText);
    if (action.action) {
      action.action(payload);
    } else null;
    setIsPopupVisible(false);
  }, [getActionPayload, selectedText]);
  const handleSelectionChange = (0, import_react2.useCallback)(() => {
    const selection = window.getSelection();
    if (!selection || selection.toString().trim().length === 0) {
      setIsPopupVisible(false);
    }
  }, []);
  useEffectOnce(() => {
    document.addEventListener("selectionchange", handleSelectionChange, { capture: true });
    return () => document.removeEventListener("selectionchange", handleSelectionChange);
  });
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    "div",
    {
      ref: containerRef,
      className: "text-highlight-container relative",
      onMouseUp: handleMouseUp,
      children: [
        children,
        isPopupVisible && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "div",
          {
            ref: popupRef,
            className: "text-highlight-popup absolute transition popup",
            style: {
              top: `${popupPosition.top}px`,
              left: `${popupPosition.left}px`
            },
            children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: "flex space-x-2 bg-transparent p-2", "aria-label": "Text highlight actions", children: actions.slice(0, 3).map((action) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: "action-container bg-white rounded shadow flex flex-row items-center p-2", children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
              "button",
              {
                type: "button",
                onClick: () => handleActionClick(action),
                className: "button button-tertiary-grey button-sm flex-grow flex items-center justify-center",
                "aria-label": action.label,
                children: [
                  action.icon && /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { className: "button-icon mr-2", "aria-hidden": "true", children: action.icon }),
                  /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { className: "button-text", children: action.label })
                ]
              }
            ) }, action.label)) })
          }
        )
      ]
    }
  );
}

// index.ts
var highlight_pop_default = TextHighlightPopup;
